#pragma once

#ifdef UNICODE

#define WCTOMB(m,w) wcstombs(m,&w,1)
#define WCSTOMBS wcstombs
inline int MBSTOWCS(wchar_t *wcs, const char *mbs, int iLen)
{
   int iNull = -1, iResult = 0;
   for (int i = 0; i < iLen; i++)
   {
      if (mbs[i] == NULL)
      {
         iNull = i;
         break;
      }
   }
   if (iNull > -1)
   {
      iResult = MultiByteToWideChar(CP_ACP, 0, mbs, iNull+1, wcs, wcs ? iNull+1 : 0);
      iResult -= 1; // mbstowcs() is not supposed to report the converted NULL
   }
   else 
      iResult = MultiByteToWideChar(CP_ACP, 0, mbs, iLen, wcs, wcs ? iLen : 0);
   return iResult;
}

#else

#define WCTOMB(m,w) (*m = w)
inline int strlcpy(TCHAR* Dest, const TCHAR* Source, int Len)
{
   // Source may not be null terminated, so we can't use strlen
   int i = Len;
   if (Dest && Source && Len)
   {
      for (i = 0; i < Len; i++, Dest++, Source++)
      {
         *Dest = *Source;
         if (*Dest == TCHAR('\0'))
            break;
      }
   }
   return i;
}
#define WCSTOMBS strlcpy
#define MBSTOWCS strlcpy

#endif // UNICODE
